Attribute VB_Name = "mdLoad"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdLoad.bas                                           *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains all the functions used during the load   *
'*procedure for the frmPrepare Form.                            *
'*These functions were the intermediate steps for reading       *
'*the Items Properties file and for reading all the MAPI folders*
'*existent inside Outlook Default Profile.                      *
'****************************************************************

Option Explicit

Sub Main()

Dim Args As String
Args = Command()

If Len(Args) > 0 And Args = "schedule" Then
    frmMMSync.Hide
    frmMMSync.synchronize
    mdUnload.closeProgram
ElseIf Len(Args) > 0 And Args = "outlook" Then 'called from button from outlook
    
    frmMMSync.Hide
    
    frmMMDialog.Show
    frmMMDialog.CommandLog.Enabled = False
    frmMMDialog.CommandClose.Enabled = False
    Wait (1)
    frmMMSync.synchronize

    frmMMDialog.CommandLog.Enabled = True
    frmMMDialog.CommandClose.Enabled = True
    frmMMDialog.SetFocus
    If frmMMSync.waitLabel.Caption = mdMMVariables.WAITLABEL_CAPTION_END Then
        frmMMDialog.Label1.Caption = mdMMVariables.WAITLABEL_CAPTION_END
        
        Wait (5)
        mdUnload.closeProgram
    Else
        frmMMDialog.Label1.Caption = frmMMSync.waitLabel.Caption
                
    End If
    
    
Else

    frmMMSync.Show
End If

End Sub
Sub loadListForProperties()
    'read from item_for_properties.db file all the item properties available for user

If doesFileExist(mdVariables.NAME_PROPERTIES_LIST_FILE) Then
    mdFileSystem.readAllItemPropertiesForUser mdVariables.NAME_PROPERTIES_LIST_FILE
Else 'if file doesn't exist, the application ends
    MsgBox "Main file for Item Properties missing. SyncClient Outlook ends.", vbExclamation
    mdUnload.closeProgram
End If

End Sub

Sub readAllFolders()
    'read the existent folders and subfolders of the 4 types
    '(Calendar, Contacts, Mail, Tasks)
    'and save their EntryID and Name in the arrays of relative type

Dim countMailFolders As Integer
Dim referFolders As Outlook.MAPIFolder, objFolder As Outlook.MAPIFolder

On Error GoTo readAllFolders_Err

'this prepares the counters for all the folders for mail type
'in order to redim the mail array
countMailFolders = 0

'read the existent subfolders for Calendar default folder
'and save all the EntryIDs and names in calendarFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"

'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.calendarFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar)))
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar), mdVariables.calendarFolders
'read the existent subfolders for Contacts default folder
'and save all the EntryIDs and names in contactsFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders
frmMMSync.printMsg "BeforeError11"
ReDim mdVariables.contactsFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)))
frmMMSync.printMsg "BeforeError12"
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderContacts), mdVariables.contactsFolders
frmMMSync.printMsg "BeforeError13"

'read the existent subfolders for Mail default folder
'and all the other user mail folders
'and save all the EntryIDs and names in mailFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'get a reference to the default MAPI folders collection,
'containing the default felders for the current profile
Set referFolders = mdVariables.nameSpace.Folders.Item(1)
frmMMSync.printMsg "BeforeError13"
'read all folders and count the mail type ones
For Each objFolder In referFolders.Folders
    If objFolder.DefaultItemType = olMailItem Then
        countMailFolders = countMailFolders + mdSyncAgent.countFolders(objFolder)
    End If
Next objFolder
'ReDim the array in order to prepare it for the recursive function readOLFolders
frmMMSync.printMsg "BeforeError14"
ReDim mdVariables.mailFolders(countMailFolders)
frmMMSync.printMsg "BeforeError15"
For Each objFolder In referFolders.Folders
    If objFolder.DefaultItemType = olMailItem Then
        'mdSyncAgent.readOLFolders objFolder, mdVariables.mailFolders
    End If
Next objFolder
frmMMSync.printMsg "BeforeError16"
'read the existent subfolders for Tasks default folder
'and save all the EntryIDs and names in tasksFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.tasksFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderTasks)))
frmMMSync.printMsg "BeforeError17"
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderTasks), mdVariables.tasksFolders
frmMMSync.printMsg "BeforeError18"
'read the existent subfolders for Notes default folder
'and save all the EntryIDs and names in notesFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.notesFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderNotes)))
frmMMSync.printMsg "BeforeError19"
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderNotes), mdVariables.notesFolders
frmMMSync.printMsg "BeforeError20"

readAllFolders_Exit:
    Exit Sub

readAllFolders_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo readAllFolders_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub
