/*
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
//

#ifndef INCL_SYNC_OUTLOOKCONFIG
    #define INCL_SYNC_OUTLOOKCONFIG
	
#include <wchar.h>


	#define CONTEXT_SPDS_OUTLOOK  TEXT("spds/outlook")
	// defined in spds/common/Constants.h
	// #define CONTEXT_SPDS_SYNCML TEXT("spds/syncml")
	#define PROPERTY_CONTACTS TEXT("contacts")
	#define PROPERTY_CALENDAR TEXT("calendar")
	
	#define SPDM_SYNCURL  TEXT("spdm.syncURL")
	#define SPDM_SERVERNAME  TEXT("spdm.serverName")
	#define SPDM_PASSWORD  TEXT("spdm.password")
	#define SPDM_USERNAME  TEXT("spdm.username")
	#define SPDM_DEVICEID  TEXT("spdm.deviceId")
	
	#define FAST        TEXT("fast")
	#define TWO_WAY     TEXT("two-way")
	#define SLOW        TEXT("slow")
	#define NONE        TEXT("none")

	#define SYNC_CONTACTS     TEXT("sync.contacts")
	#define SYNC_APPOINTMENTS TEXT("sync.appointments")
    #define SYNC_TASKS        TEXT("sync.tasks")
    #define SYNC_NOTES        TEXT("sync.notes")


    #define APPOINTMENTS_NAME   TEXT("calendar")
	#define CONTACTS_NAME       TEXT("contact")
    #define TASKS_NAME          TEXT("task")
    #define NOTES_NAME          TEXT("note")


	#define CONTEXT_SPDS_SOURCES_CONTACTS       TEXT("spds/sources/contacts")
	#define CONTEXT_SPDS_SOURCES_APPOINTMENTS   TEXT("spds/sources/appointments")
    #define CONTEXT_SPDS_SOURCES_TASKS          TEXT("spds/sources/tasks")
	#define CONTEXT_SPDS_SOURCES_NOTES          TEXT("spds/sources/notes")

    #define PROPERTY_SOURCEPROP_SPDM_REMOTE_SETTINGS   TEXT("spdm.showRemoteSettings") 
    #define PROPERTY_SOURCEPROP_REMOTE_SETTINGS        TEXT("showRemoteSettings") 

    #define PROPERTY_SOURCEPROP_SPDM_LOG_LEVEL   TEXT("spdm.logLevel") 
    #define PROPERTY_SOURCEPROP_LOG_LEVEL        TEXT("logLevel") 

    #define PROPERTY_SOURCEPROP_SPDM_SHOW   TEXT("spdm.show") 
    #define PROPERTY_SOURCEPROP_SHOW        TEXT("show") 

    #define CONTEXT_SPDS_SOURCESPROP TEXT("spds/sourcesprop")

	#define DIM_MANAGEMENT_PATH 512
	#define VALUESIZE  512
	

	class __declspec(dllexport) OutlookConfig {

	

	public:   
		OutlookConfig();
		bool saveOutlookConfigToDM(wchar_t* propertyName, wchar_t* propertyValue, wchar_t* context_spds);
		int setConfigParameters(wchar_t* syncURL, wchar_t* serverName, wchar_t* username, wchar_t* password, wchar_t* deviceId,  wchar_t* errorMsg);
		int setSourceParameter (wchar_t* sourcename, wchar_t* propertyName, wchar_t* propertyValue, wchar_t* errorMsg);
		int getSourceParameter (wchar_t* name, wchar_t* propertyName, wchar_t* value);
		int getConfigParameter (wchar_t* name, wchar_t* value);
		int init(int sourceCount);
		int config();
        int getClientConfigurationOutlook (wchar_t* sourceName, wchar_t* propertyName, wchar_t* propertyValue);
        int setClientConfigurationOutlook(wchar_t* sourceName, wchar_t* propertyName, wchar_t* propertyValue);
	};

#endif